#################################
##\uk-ߖT@v
#################################

library(FNN)
library(kknn)

#################
## k-NNxR[h

#Z is query point matrix, X is data.
knn.density <- function(Z,X,k=10){
	dd <- dim(X)
	n <- dd[1]
	d <- dd[2]
	tmp <- matrix(0,length(Z[,1]),d)
	tmp <- knnx.dist(X,Z,k=k)
	res <- k/n/(pi^(d/2)/gamma(d/2+1)*tmp[,k]^d)
}

#################################
## cJ̒Ã}Vif[^
## i (price) Ɩʐ (area) ̕z߂D
## 񎟌f[^̖x֐

#f[^̓ǂݍ
x <- read.csv("setagaya_manshion.csv",header=T)
ind = grep("P",x[[4]])
Y = 0*c(1:length(x[[1]]))
Y[ind] = 1
Y = factor(Y)
sman = data.frame(price=x[[1]],walk=x[[3]],area=x[[5]],str=ifelse(x[[6]]=="qb",1,0),kenpei=x[[7]],youseki=x[[8]],tikunen=x[[9]],kyuko=x[[10]]) #\̓_~[
plot(sman$price,sman$area,xlab="price",ylab="area")

#Pf[^̍쐬
train = matrix(0,length(Y),2)
train[,1] = sman$price/sd(sman$price) #f[^̃XP[𑵂
train[,2] = sman$area/sd(sman$area) #f[^̃XP[𑵂
colnames(train) <- c("price","area")
sman.sd = c(sd(sman$price),sd(sman$area))

#vbgpObhf[^̍쐬
dif = max(train[,1])-min(train[,1])
x1 = seq(min(train[,1])-dif*0.05,max(train[,1])+dif*0.05,len=100)
dif = max(train[,2])-min(train[,2])
x2 = seq(min(train[,2])-dif*0.05,max(train[,2])+dif*0.05,len=100)
xgrid = expand.grid(x1,x2)
prob <- knn.density(xgrid,train,k=30)
prob_mat <- matrix(prob, length(x1), length(x2))

#q[g}bṽvbg
image(x = x1*sman.sd[1], y = x2*sman.sd[2], z = prob_mat,xlab = "price",
ylab = "area",main="k=30")
par(new=F)
points(train[,1]*sman.sd[1],train[,2]*sman.sd[2])
contour(x1*sman.sd[1],x2*sman.sd[2], prob_mat, add=TRUE)

#Ր}̃vbg
persp(x = x1*sman.sd[1], 
  y = x2*sman.sd[2], 
  z = prob_mat,
  xlab = "price",
  ylab = "area",
  zlab = "estimated density",
  theta = 45, axes = TRUE, box = TRUE)

####################
#1ƂȊO𔻕

res = knn(train, xgrid, Y, k = 10, prob=TRUE)
prob <- attr(res, "prob")
prob <- ifelse(res=="1", prob, 1-prob)

plot(train[,1]*sman.sd[1],train[,2]*sman.sd[2], col=ifelse(Y==1, "coral", "cornflowerblue"),main="",xlab="price",ylab="area")
contour(x = x1*sman.sd[1], y = x2*sman.sd[2], z = matrix(prob,length(x1),length(x2)),levels=0.5, add=TRUE)
points(x = xgrid[,1]*sman.sd[1], y = xgrid[,2]*sman.sd[2], pch=".", cex=1.2, col=ifelse(prob>=0.5, "coral", "cornflowerblue"))
box()


#############################################
# MNIST菑F
# k-NN

data.train_origin <- read.csv("train_data.csv",header=FALSE) #Pf[^̓ǂݍ
data.test <- read.csv("test_data.csv",header=FALSE) #eXgf[^̓ǂݍ

train_size <- dim(data.train_origin)
dimx <- train_size[2] - 1
dimy <- train_size[2]
res = knn(data.train_origin[,1:dimx], data.test[,1:dimx], data.train_origin[,dimy], k = 10, prob=FALSE) #vZɂ͐
clerr = mean(res!=data.test[,dimy]) # 0.0335, 96.65%̊mŐD
table(res,data.test[,dimy])

# Ԉ̕\
show_digit <- function(arr784, col=gray(12:1/12), ...) {
  x <- expand.grid(1:28,1:28)
  image(matrix(arr784, nrow=28)[,28:1], col=col, ...)
}
misclss_ind <- sample(which((res!=data.test[,dimy])),3)
show_digit(as.numeric(data.test[misclss_ind[1],1:dimx]))
show_digit(as.numeric(data.test[misclss_ind[2],1:dimx]))
show_digit(as.numeric(data.test[misclss_ind[3],1:dimx]))

##############
## k-NN̐}
library(ElemStatLearn)
require(class)

data(mixture.example)
x <- mixture.example$x
g <- mixture.example$y
xnew <- mixture.example$xnew
mod15 <- knn(x, xnew, g, k=15, prob=TRUE)
prob <- attr(mod15, "prob")
prob <- ifelse(mod15=="1", prob, 1-prob)
px1 <- mixture.example$px1
px2 <- mixture.example$px2
prob15 <- matrix(prob, length(px1), length(px2))

par(mar=rep(2,4))
contour(px1, px2, prob15, levels=0.5, labels="", xlab="", ylab="", main=
        "15-nearest neighbour", axes=FALSE)
points(x, col=ifelse(g==1, "coral", "cornflowerblue"))
gd <- expand.grid(x=px1, y=px2)
points(gd, pch=".", cex=1.2, col=ifelse(prob15>0.5, "coral", "cornflowerblue"))
box()

